C	VERSION D.ESPINAT (19/12/83) IFP VAX LABO DX (DERFFT.FOR)
C
C
C	*****************************************************************
C	*                                                               * 
C	*  PROGRAMME DISTRIBUTION ELECTRONIQUE RADIALE                  * 
C	*  ( FICHIER DERFFT.FOR,.OBJ,.EXE )                             * 
C	*                                                               * 
C	*****************************************************************
C
C	CE PROGRAMME FONCTIONNE UNIQUEMENT EN BATCH SUR VAX
C	IL EST LANCE A L AIDE DE LA PROCEDURE DERFFT.COM
C	LA COMMANDE EST LA SUIVANTE BFFT.
C
C	Le PROGRAMME DERFFT qui va suivre calcule la transformee de 
C	FOURIER de la fonction SI(S): 
C	         S MAX
C	  SOMME          SI(S)*SIN(2*PI*R*S) dS
C	         S MIN
C
C	Rappelons qu'un premier programme a ete appele pour remettre
C	le spectre de diffraction a l'echelle absolue (DERB.FOR)
C	D'une facon plus generale on peut calculer la transformee de 
C	fourier pour un fonction quelconque f(s),par exemple WIJ,WPJ...
C	(voir programme DERB.FOR).
C
C	Apres lecture du fichier de donnees , on va redecouper 
c	le domaine en S etudie a pas constants (rappelons que pour
C	le moment l'enregistrement des spectres de diffraction se fait
C	a pas 2TETA CONSTANTS (S=2*SIN(TETA)/LAMBDA))
C	Une interpolation des valeurs de l intensite diffusee est alors
C	necessaire ; elle est realisee a partir de la soubroutine INTERP
C	
C	La TRANSFORMEE DE FOURIER est calculee a partir d un algorithme
C	de fft rapide issu de la librairie IMSL (FFTCC)
C	L echantillonnage normal de la fft est determine par 1/S MAX
C	Cett valeur est insuffisante pour avoir une bonne definition
C	de la distribution radiale . On fait alors l'hypothese que la
C	fonction SI(S) est connue plus loin en S . D apres la theorie	
C	la fonction SI(S) tend vers zero lorsque S devient grand .
C	ON PROLONGERA JUSQU A S MAX DE FACON QUE DELTA(R)=1/(S MAX)
C	On aura alors un echantillonnage en R egal a DELTA(R)
C
C
C
	PROGRAM DISTRIBUTION ELECTRONIQUE RADIALE
C
C
C
	DIMENSION REXP(250000),DER(250000),DAR(250000)
	DIMENSION SINK(250000),SONK(250000),WIM(250000),RE(250000)
	DIMENSION SINU(250000),RO(250000),DE(5),DUR(250000)
	INTEGER IWK(250000),IPF(13),IEXP(13),IPWR(13)
	REAL WK(250000)
	COMPLEX F(250000)
	INTEGER TXB,N,M,MRE,MRI,MRU,MMQ,NNBS,NMQ,M2
	DOUBLE PRECISION THETAO,STEP,THE,ROE
	DOUBLE PRECISION ST,LAMBDA,XDER
	DOUBLE PRECISION X,Y,Q,HSD,MQ,SS,R,XMQ,RMAX
	DOUBLE PRECISION REP,ECHF,SMAX,SIN4,SMA,XNBS
	DATA PI/3.1415927/
	DATA CONV/8.7267E-3/
C
C
C	LECTURE DES DONNEES FICHIER .SIS
C
C
	READ(7,*,END=1230) REXP
1230	ROE=REXP(1)
	LAMBDA=REXP(2)
	TXB=REXP(3)
	THE=REXP(4)
	ST=REXP(5)
	DO 1240 I=1,TXB
1240	REXP(I)=REXP(I+5)
	THETAO=THE*CONV
	STEP=ST*CONV
	DO 1100 I=1,TXB
1100	SINU(I)=2*SIN(THETAO+(I-1)*STEP)/LAMBDA
C
C
C	DEFINITION DU PAS POUR LE NOUVEL ECHANTILLONNAGE EN S
C
C
	READ(8,*)Q
	HSD=(SINU(TXB)-SINU(1))/Q
	SINK(1)=SINU(1)
	MQ=Q+1
1360	DO 1160 L=2,MQ
	SINK(L)=SINK(1)+(L-1)*HSD
	XXA=SINK(L)
C
C
C	INTERPOLATION SUR LA FONCTION F(S)
C
C
	CALL INTERP(TXB,SINU,REXP,XXA,YA,IR)
	SONK(L)=YA
1160    CONTINUE
	IF(SINK(MQ). NE. SINU(TXB)) TYPE 1170
1170	FORMAT(' ERREUR ')
	DO 1161 L=2,MQ
1161	SINK(L)=(L-1)*HSD
C
C
C	PROLONGATION DE LA FONCTION F(S) (- SMAX) ET ECHANTILLONNAGE (ECHF)
C
C
	READ(8,*) REP
	IF(REP.EQ.0) GOTO 1341
	READ(8,*) ECHF
	SMAX=1./ECHF
	XNBS=(SMAX-SINK(MQ))/HSD
	XNBS=XNBS+0.5
	NNBS=NINT(XNBS)
	SSMA=HSD*NNBS+SINK(MQ)
	MMQ=MQ+NNBS
	DO 1342 I=(MQ+1),MMQ
1342	SONK(I)=0.
1341	SONK(1)=REXP(1)
	DO 1140 I=1,MMQ
1140	F(I)=CMPLX(SONK(I),0.)
C
C
C	CALCUL DE LA FFT
C
C
	N=MMQ
C
	CALL VDCPS(N,NPF,IPF,IEXP,IPWR)
	M=0
	K=1
	JK=1
	DO I=1,NPF
	M=M+IEXP(I)
	I11=IPF(I)
	K=JMAX0(K,I11)
	JK=JK*IPF(I)**(IEXP(I)/2)
	END DO
	KB=N/JK**2-2
	IWORD=3*M+3+JMAX0(4*M+7+6*K,KB+1+2*JK)
C
	CALL FFTCC(F,MMQ,IWK,WK)	
C
C
C
	RPAS=1./SSMA
C
C
C	CORRECTION DU AU FAIT QUE LA FONCTION N EST CONNUE
C	QU'A PARTIR DE SMIN (DEPHASAGE)
C
C
	DO 1141 I=1,MMQ
	WIM(I)=AIMAG(F(I))
1141	RE(I)=REAL(F(I))
	DO 1382 I=1,MMQ
	RO(I)=(I-1)*RPAS
	XDER=COS(2*PI*RO(I)*SINU(1))*WIM(I)
1382	DER(I)=XDER+SIN(2*PI*RO(I)*SINU(1))*RE(I)	
C
C
C	CREATION OU NON D UN FICHIER POUR LE REDECOUPAGE EN S
C
C
	READ(8,*) MRE
	IF(MRE.EQ.0) GOTO 1130
C
C
	WRITE(1,*)MQ
	WRITE(1,*) SINK(1)
	WRITE(1,*) HSD
	DO 1421 I=1,MQ,5
1421	WRITE(1,1384) (SONK(J),J=I,I+4)
	CLOSE(UNIT=1)
C
C
C	CREATION D UN FICHIER RECAPITULANT LES DONNEES EN S ET EN R
C	POUR CALCULER LA TRANSFORMEE DE FOURIER
C	   FICHIER DE DEPART (NB DE POINTS,SMIN, SMAX,2TETA MIN,...
C	   FICHIER TRAITE PAR FFTCC (SMIN , DELTA S, S MAX , DELTA R
C	   , NOMBRE DE POINTS)
C
C
1130	WRITE(2,1375)
1375	FORMAT(' RENSEIGNEMENTS SUR LE FICHIER SI(S) DE DEPART ',/,
	160('*'))
	WRITE(2,1371) TXB
1371	FORMAT(' NOMBRE DEPOINTS DU FICHIER SI(S) DE DEPART : ',I8)
	WRITE(2,1372) THE,SINU(1)
1372	FORMAT(//' ANGLE DE DEPART DU FICHIER SI(S) : ',F14.8,/,'
	1 VALEUR DE S CORRESPONDANTE : ',F14.8)
	WRITE(2,1373) ST
1373	FORMAT(//' PAS EN 2 THETA : ',F14.8)
	WRITE(2,1374) SINU(1),SINU(TXB)
1374	FORMAT(' VALEUR INITIALE DE S : ',F14.8,' VALEUR FINALE DE S : ',
	1F14.8)
	DE(1)=SINU(2)-SINU(1)
	DE(2)=SINU(TXB)-SINU(TXB-1)
	WRITE(2,1376) DE(1),DE(2)
1376	FORMAT(' VALEURS DE DELTA S INITIALE ET FINALE : ',F14.8,'
	1   ',F14.8)
	WRITE(2,1377)
1377	FORMAT(' RENSEIGNEMENTS CONCERNANT LE FICHIER SI(S) POUR LA DER ',
	1/,60('*'),//)
	WRITE(2,1378) Q
1378	FORMAT(' NOMBRE DE PAS POUR LA FFT ',F14.4)
	WRITE(2,1379) HSD
1379	FORMAT(' PAS EN S CHOISI POUR LA FFT ',F14.8)
	IF(REP.EQ.0) GOTO 1391
	WRITE(2,1390) ECHF
1390	FORMAT(' ECHANTILLONNAGE CHOISI POUR LA FFT : ',F14.8)
	WRITE(2,1392) SSMA
1392	FORMAT(' VALEUR DE S MAX POUR LA FFT : ',F14.8)
	WRITE(2,1393) MMQ
1393	FORMAT(' NOMBRE DE POINTS TOTAL DU FICHIER SI(S) POUR LA FFT: ',
	1I7)
	WRITE(2,1394) RPAS
1394	FORMAT(' ECHANTILLONNAGE VRAI DE LA FFT : ',F14.8)	
1391	CLOSE(UNIT=2)
C
C
C	CREATION D UN FICHIER POUR LA DER LISIBLE SUR CALCOMP
C
C
	READ(8,*) M2
	READ(8,*) RMAX
	NMQ=(RMAX/RPAS)+1
	DO 1386 I=1,NMQ
	DAR(I)=DER(I)*RO(I)*8.*PI
1386	DAR(I)=DAR(I)/10000.
C
	GOTO(1400,1401,1400) M2
C
1400	WRITE(9,*) NMQ
	WRITE(9,*) 0.
	WRITE(9,*) RPAS
	DO 1383 I=1,NMQ,5
1383	WRITE(9,1384) (DAR(J),J=I,I+4)
1384	FORMAT(5(1X,F14.5))
	IF(M2.EQ.1) GOTO 1403
1401	IF(M2.EQ.2) NUNIT=9
	IF(M2.EQ.3) NUNIT=10
	WRITE(NUNIT,*) NMQ
	WRITE(NUNIT,*) 0.
	WRITE(NUNIT,*) RPAS
	DO 1385 I=1,NMQ
1385	DUR(I)=DER(I)*RO(I)*8.*PI+4.*PI*ROE*(RO(I)**2)
	DO 1404 I=1,NMQ,5
	DUR(J)=DUR(J)/10000.
1404	WRITE(NUNIT,1384) (DUR(J),J=I,I+4)
	IF(M2.EQ.2.OR.M2.EQ.1)	CLOSE(UNIT=9)
	IF(M2.EQ.3) CLOSE(UNIT=10)
	IF(M2.EQ.3) CLOSE(UNIT=9)
C
C
1403	END
C
C
C
C	*******************************************
	SUBROUTINE INTERP(N,X,Y,XA,YA,IR)
C	*******************************************
C
C	VOIR THEORIE ET PRATIQUE DE LA PROGRAMMATION FORTRAN
C	    J.VIGNES M.LA PORTE  (EDITIONS TECHNIP) ANNEXES p 216
C
C
        DIMENSION X(1),Y(1),P(2)
      IF(N-2) 8,6,1                                                          
    1 IR=0                                                                   
      SENS=X(N)-X(1)                                                         
      DO 2 I=2,N                                                             
      IF(SENS*(XA-X(I)).LE.0.) GO TO 3                                       
    2 CONTINUE                                                               
      IR=1                                                                   
      I=N                                                                   
      GO TO 4                                                               
    3 IF(SENS*(XA-X(1)).LT.0.) IR=1                                         
    4 K1=MAX0(I-1,2)                                                        
      K2=MIN0(I,N-1)                                                        
      DO 5 K=K1,K2                                                          
      DX1=X(K+1)-X(K)                                                       
      DX2=X(K+1)-X(K-1)                                                     
      DX3=X(K)-X(K-1)                                                       
      IF(DX1*DX2*DX3*SENS.LE.0.) GO TO 8                                    
      DA1=XA-X(K-1)                                                         
      DA2=XA-X(K)                                                           
      DA3=XA-X(K+1)                                                         
      J=K-K1+1                                                              
    5 P(J)=Y(K-1)*DA2*DA3/(DX2*DX3)-Y(K)*DA1*DA3/(DX1*DX3)+Y(K+1)*DA1*DA    
     12/(DX1*DX2)                                                           
      YA=P(1)                                                               
      IF(J.EQ.2) YA=(DA1*P(2)-DA2*P(1))/DX3                                 
      RETURN                                                                
    6 DA1=XA-X(1)                                                           
      DA2=X(2)-XA                                                           
      DA3=X(2)-X(1)                                                         
      IR=0                                                                  
      IF(DA1*DA2.LT.0.) IR=1                                                
      IF(DA3) 7,8,7                                                         
    7 YA=(Y(1)*DA2+Y(2)*DA1)/DA3                                            
      RETURN                                                                
    8 IR=-1                                                                 
	YA=32767
      PRINT 100                                                             
  100 FORMAT(1X,'* SOUS PROGRAMME SGT . TABLE INCORRECTE*')                    
      RETURN                                                                
      END                                                                   
C
C
C
